      *=====================================================================*
      *  RPGUnit: Test BASIC Authentication                                 *
      *=====================================================================*
      *   >>PRE-COMPILER<<                                                  *
      *     >>CRTCMD<<  RUCRTTST    TSTPGM(&LI/&OB) +                       *
      *                             SRCFILE(&SL/&SF);                       *
      *     >>COMPILE<<                                                     *
      *       >>PARM<< COPTION(*SRCSTMT);                                   *
      *       >>PARM<< DBGVIEW(*LIST);                                      *
      *       >>PARM<< BNDSRVPGM(BASICS1 HTTPAPIR4);                        *
      *       >>PARM<< BNDDIR(&LI/WSDLJUNIT);                               *
      *     >>END-COMPILE<<                                                 *
      *     >>EXECUTE<<                                                     *
      *   >>END-PRE-COMPILER<<                                              *
      *=====================================================================*
     H NoMain Option(*SrcStmt)
      *
      /copy RPGUNIT1,TESTCASE
      /copy QRPGLESRC,HTTPAPI_H                    HTTPAPI
      /copy QBASICS1,PBASICS1                      Tools/400 Runtime Library
      *
     D setUp...
     D                 PR                  extproc('setUp')
      *
     D tearDown...
     D                 PR                  extproc('tearDown')
      *
     D test_basic_auth_1...
     D                 PR                  extproc('+
     D                                     test_basic_auth_1+
     D                                     ')
      *
     D test_digest_auth_1...
     D                 PR                  extproc('+
     D                                     test_digest_auth_1+
     D                                     ')
      *
     D test_digest_auth_2...
     D                 PR                  extproc('+
     D                                     test_digest_auth_2+
     D                                     ')
      *
     D test_digest_auth_3...
     D                 PR                  extproc('+
     D                                     test_digest_auth_3+
     D                                     ')
      *
     D Job_getTcpIpAddr...
     D                 PR            15A          varying
      *
     D receiveResponse...
     D                 PR            10I 0 extproc('receiveResponse')
     D  i_fd                         10I 0 value
     D  i_pData                        *   value
     D  i_length                     10I 0 value
      *
     D g_status        DS                  qualified
     D  text                        128A   varying inz
      *
      *===============================================================*
      *  Set up test case
      *===============================================================*
     P setUp...
     P                 B                   export
     D                 PI
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /free

      /end-free
     P                 E
      *
      *===============================================================*
      *  Tear down test case
      *===============================================================*
     P tearDown...
     P                 B                   export
     D                 PI
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /free


      /end-free
     P                 E
      *
      *===============================================================*
      *  Returns the IP address of the 5250 client of the
      *  specified job.
      *===============================================================*
     P Job_getTcpIpAddr...
     P                 B                   export
     D                 PI            15A          varying
      *
      *  Retrieve Job Information (QUSRJOBI) API
     D QUSRJOBI...
     D                 PR                  extpgm('QUSRJOBI')
     D  o_rcvVar                  65535A          options(*varsize)
     D  i_rcvVarLen                  10I 0 const
     D  i_format                      8A   const
     D  i_qJob                       26A   const
     D  i_intJobID                   16A   const
     D  io_errCode                65535A          options(*nopass: *varsize)    OptGrp 1
     D  i_resPrfStat                  1A   const  options(*nopass)              OptGrp 2
      *
     D qJob            DS                  qualified
     D  name                         10A   inz('*')
     D  user                         10A   inz
     D  nbr                           6A   inz
      *
     D jobi0600        DS                  qualified
     D  jobType               61     61A
     D  jobSubType            62     62A
     D  device               127    136A
      *
      *  Retrieve Device Description (QDCRDEVD) API
     D QDCRDEVD...
     D                 PR                         extpgm('QDCRDEVD')
     D  o_rcvVar                  65535A          options(*varsize)
     D  i_lenRcvVar                  10I 0 const
     D  i_format                      8A   const
     D  i_devName                    10A   const
     D  io_errCode                65535A          options(*varsize)

     D devd0600        DS          1024    qualified
     D  tcpIpDotAddr         878    892A

     D errCode         DS                  inz
     D  bytPrv                       10I 0
     D  bytAvl                       10I 0
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE
         QUSRJOBI(jobi0600:%size(jobi0600):'JOBI0600':qJob:'':errCode);
         QDCRDEVD(devd0600:%size(devd0600):'DEVD0600':jobi0600.device:errCode);
         return %trim(devd0600.tcpIpDotAddr);
      /END-FREE
     P                 E
      *
      *===============================================================*
      *  Receive response from HTTP server.
      *===============================================================*
     P receiveResponse...
     P                 B                   export
     D                 PI            10I 0
     D  i_fd                         10I 0 value
     D  i_pData                        *   value
     D  i_length                     10I 0 value
      *
     D data            S           1024A   based(i_pData)
      *
     D response        DS                  qualified
     D  value                      1024A   varying
     D  length                 1      2I 0
     D  data                   3   1026A
      *
     D html            DS                  qualified
     D  title                       128A   varying inz
     D  body                        128A   varying inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /free

         response.value = %subst(data: 1: i_length);

         http_xlate(i_length: response.data: TO_EBCDIC);

         XML-INTO html %XML(response.value
                            : 'allowmissing=yes allowextra=yes');

         g_status.text = html.body;

         return i_length;

      /end-free
     P                 E
      *
      *===============================================================*
      *  Test:   BASIC Authentication
      *---------------------------------------------------------------*
      *  Works nicely as expected.
      *===============================================================*
     P test_basic_auth_1...
     P                 B                   export
     D                 PI
      *
     D URL             S            300A    varying
     D rc              S             10I 0  inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /free

         http_debug(*ON: '/home/raddatz/wsdl2rpg/test105_basic_1.log');

         URL = 'http://admin' + Job_getTcpIpAddr() + ':8080/basic/';

         clear g_status;
         rc = http_url_get_raw(URL: 0: %paddr('receiveResponse'));

         iEqual(1: rc);
         iEqual(31: %len(g_status.text));
         aEqual('BASIC Authentication validated.': g_status.text);

      /end-free
     P                 E
      *
      *===============================================================*
      *  Test:   DIGEST Authentication
      *---------------------------------------------------------------*
      *  This is how I actually expected HTTPAPI to work.
      *  At the first GET, HTTPAPI receives an 401 error code because
      *  it tries to use BASIC authentication, first.
      *  But then, after having set DIGEST authentication I thought
      *  that HTTPAPI should retrieve the user and password from the
      *  URL and add the DIGEST authentication header.
      *===============================================================*
     P test_digest_auth_1...
     P                 B                   export
     D                 PI
      *
     D URL             S            300A    varying
     D rc              S             10I 0  inz
      *
     D err             S             10I 0
     D basic           S              1N
     D digest          S              1N
     D realm           S            124A
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /free

         http_debug(*ON: '/home/raddatz/wsdl2rpg/test105_digest_1.log');

         URL = 'http://admin' + Job_getTcpIpAddr() + ':8080/digest/';

         clear g_status;
         rc = http_url_get_raw(URL: 0: %paddr('receiveResponse'));
         if (rc <> 1);
            http_error(err);
            if (err = HTTP_NDAUTH);
               // Sine I know that the server uses DIGEST authentication,
               // I try to set it right now without http_getAuth().
               http_setAuth(HTTP_AUTH_MD5_DIGEST: '': '');
               rc = http_url_get_raw(URL: 0: %paddr('receiveResponse'));
            else;
               fail('Expected to get an authorization error: err='+%char(err));
            endif;
         else;
            fail('Expected to get an authorization error: rc='+%char(rc));
         endif;

         iEqual(1: rc);
         iEqual(31: %len(g_status.text));
         aEqual('DIGEST Authentication validated.': g_status.text);

      /end-free
     P                 E
      *
      *===============================================================*
      *  Test:   DIGEST Authentication
      *---------------------------------------------------------------*
      *  This time I try to use URL authentication with the first
      *  GET and then, after having set DIGEST authentication I try it
      *  again with a standard URL.
      *===============================================================*
     P test_digest_auth_2...
     P                 B                   export
     D                 PI
      *
     D URL             S            300A    varying
     D rc              S             10I 0  inz
      *
     D err             S             10I 0
     D basic           S              1N
     D digest          S              1N
     D realm           S            124A
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /free

         http_debug(*ON: '/home/raddatz/wsdl2rpg/test105_digest_2.log');

         URL = 'http://admin' + Job_getTcpIpAddr() + ':8080/digest/';

         clear g_status;
         rc = http_url_get_raw(URL: 0: %paddr('receiveResponse'));
         if (rc <> 1);
            http_error(err);
            if (err = HTTP_NDAUTH);
               http_getauth(basic: digest: realm);
               if (digest);
                  http_setAuth(HTTP_AUTH_MD5_DIGEST: 'admin': '');
                  URL = 'http://' + Job_getTcpIpAddr() + ':8080/digest/';
                  rc = http_url_get_raw(URL: 0: %paddr('receiveResponse'));
               else;
                  fail('Expected to be asked to use DIGEST authentication.');
               endif;
            else;
               fail('Expected to get an authorization error: err='+%char(err));
            endif;
         else;
            fail('Expected to get an authorization error: rc='+%char(rc));
         endif;

         iEqual(1: rc);
         iEqual(31: %len(g_status.text));
         aEqual('DIGEST Authentication validated.': g_status.text);

      /end-free
     P                 E
      *
      *===============================================================*
      *  Test:   DIGEST Authentication
      *---------------------------------------------------------------*
      *  DIGEST authentication without URL authentication works
      *  as nicely.
      *===============================================================*
     P test_digest_auth_3...
     P                 B                   export
     D                 PI
      *
     D URL             S            300A    varying
     D rc              S             10I 0  inz
      *
     D err             S             10I 0
     D basic           S              1N
     D digest          S              1N
     D realm           S            124A
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /free

         http_debug(*ON: '/home/raddatz/wsdl2rpg/test105_digest_3.log');

         URL = 'http://' + Job_getTcpIpAddr() + ':8080/digest/';

         clear g_status;
         rc = http_url_get_raw(URL: 0: %paddr('receiveResponse'));
         if (rc <> 1);
            http_error(err);
            if (err = HTTP_NDAUTH);
               http_getauth(basic: digest: realm);
               if (digest);
                  http_setAuth(HTTP_AUTH_MD5_DIGEST: 'admin': '');
                  rc = http_url_get_raw(URL: 0: %paddr('receiveResponse'));
               else;
                  fail('Expected to be asked to use DIGEST authentication.');
               endif;
            else;
               fail('Expected to get an authorization error: err='+%char(err));
            endif;
         else;
            fail('Expected to get an authorization error: rc='+%char(rc));
         endif;

         iEqual(1: rc);
         iEqual(32: %len(g_status.text));
         aEqual('DIGEST Authentication validated.': g_status.text);

      /end-free
     P                 E
      *
